import { browser, getUrlCode } from '@/helpers/utils'
import { Cell, CellGroup, closeToast, Icon, Loading, showConfirmDialog, showDialog } from 'vant'
import { defineComponent, onMounted, reactive } from 'vue'
import { useRouter, useRoute } from 'vue-router'
import styles from './index.module.less'

export default defineComponent({
  name: 'pay-result',
  setup() {
    const router = useRouter()
    const route = useRoute()
    const state = reactive({
      errorText: '',
      browserStatus: false,
      payType: '',
      payMap: {} as any,
      code: ''
    })

    const init = () => {
      // 判断是否有支付对象
      if (!state.payMap || !state.payType) {
        showConfirmDialog({
          message: '支付订单信息错误请重新支付'
        }).then(() => {
          router.back()
        })
      } else {
        // state.amount = changeTwoDecimal(state.payMap.amount)
        // 判断当前浏览器
        if (browser().weixin) {
          state.browserStatus = true
          getWxPay()
        } else if (browser().alipay) {
          state.browserStatus = true
          getPayment()
        } else {
          state.errorText = '请在微信或支付宝客户端打开'
          document.title = 'ERROR'
        }
      }
    }

    const getPayment = () => {
      try {
        // if (!(parseFloat(this.amount) > 0)) {
        //   this.$toast('支付金额异常')
        //   return
        // }
        // let { orderNo, sign, amount, orderBody, orderSubject, tenantId, returnUrl, notifyUrl } =
        //   this.payMap
        // returnUrl = returnUrl.replace(/\^\^/gi, '&')
        // // 处理老师支付问题
        // const tempPlatform = this.platform == 'teacher' ? 'student' : this.platform
        // let that = this,
        //   payMap = {
        //     orderNo: orderNo,
        //     sign: sign,
        //     amount: numeral(amount).format('0.00'),
        //     orderBody: orderBody,
        //     orderSubject: orderSubject,
        //     payChannel: this.payType, // 支付渠道
        //     platform: tempPlatform,
        //     tenantId: tenantId,
        //     returnUrl: returnUrl,
        //     notifyUrl: notifyUrl
        //   }
        // // 判断是否是微信公众号支付
        // if (this.payType == 'wx_pub') {
        //   payMap.code = this.code
        // }
        // this.$toast.loading({
        //   duration: 0,
        //   message: '加载中...',
        //   forbidClick: true
        // })
        // executePayment(payMap)
        //   .then((res) => {
        //     this.$toast.clear()
        //     let result = res.data
        //     if (result.code == 200) {
        //       let payment = result.data
        //       if (payment.status === 'succeeded') {
        //         this.scanCodePay(payment)
        //       } else if (payment.status == 'failed') {
        //         this.browserStatus = false
        //         this.errorText = payment.error_msg
        //         document.title = 'ERROR'
        //       } else if (payment.status == 'pending') {
        //         this.$dialog.alert({
        //           title: '提示',
        //           message: '订单处理中...',
        //           confirmButtonColor: '#269a93'
        //         })
        //       }
        //     } else {
        //       showDialog({
        //         title: '提示',
        //         message: result.msg,
        //         confirmButtonColor: '#269a93'
        //       })
        //     }
        //   })
        //   .catch((err) => {
        //     closeToast()
        //     showDialog({
        //       title: '提示',
        //       message: JSON.stringify(err),
        //       confirmButtonColor: '#269a93'
        //     })
        //   })
      } catch {
        //
      }
    }
    const scanCodePay = (data: any) => {
      // 判断支付方式 如果是 test 模式 支付用测试url 否则用生产url
      // if (state.payType == 'alipay_wap') {
      //   window.location.href = data.expend.pay_info
      // } else if (state.payType == 'wx_pub') {
      //   const tempPayInfo = JSON.parse(data.expend.pay_info)
      //   state.payInfo = tempPayInfo
      //   if (typeof WeixinJSBridge == 'undefined') {
      //     if (document.addEventListener) {
      //       document.addEventListener('WeixinJSBridgeReady', onBridgeReady, false)
      //     } else if (document.attachEvent) {
      //       document.attachEvent('WeixinJSBridgeReady', onBridgeReady)
      //       document.attachEvent('onWeixinJSBridgeReady', onBridgeReady)
      //     }
      //   } else {
      //     state.onBridgeReady()
      //   }
      // }
    }
    const onBridgeReady = () => {
      // let payInfo = this.payInfo
      // WeixinJSBridge.invoke(
      //   'getBrandWCPayRequest',
      //   {
      //     appId: payInfo.appId, //公众号名称，由商户传入
      //     timeStamp: payInfo.timeStamp, //时间戳，自1970年以来的秒数
      //     nonceStr: payInfo.nonceStr, //随机串
      //     package: payInfo.package,
      //     signType: payInfo.signType, //微信签名方式：
      //     paySign: payInfo.paySign //微信签名
      //   },
      //   (res) => {
      //     // if(res.err_msg == "get_brand_wcpay_request:ok" ){
      //     // 使用以上方式判断前端返回,微信团队郑重提示：
      //     //res.err_msg将在用户支付成功后返回ok，但并不保证它绝对可靠。
      //     // } else
      //     // 支付取消或支付失败
      //     let { orderNo } = this.payMap
      //     if (
      //       res.err_msg == 'get_brand_wcpay_request:cancel' ||
      //       res.err_msg == 'get_brand_wcpay_request:fail'
      //     ) {
      //       // 用户取消支付
      //       if (this.platform == 'manager') {
      //         // 管理端
      //         window.location.replace(
      //           validManageUrl() + '/#/paymentResult?orderNo=' + orderNo + '&isBack=off'
      //         )
      //       } else if (this.platform == 'teacher') {
      //         // 老师端
      //         window.location.replace(
      //           validTeacherUrl() + '/#/paymentResult?orderNo=' + orderNo + '&isBack=off'
      //         )
      //       } else {
      //         this.$router.replace({
      //           path: '/paymentResult',
      //           query: {
      //             type: 'error',
      //             orderNo: orderNo,
      //             isBack: 'off'
      //           }
      //         })
      //       }
      //     } else {
      //       // 使用以上方式判断前端返回,微信团队郑重提示：
      //       //res.err_msg将在用户支付成功后返回ok，但并不保证它绝对可靠。
      //       // this.$router.replace({
      //       //   path: "/paymentResult",
      //       //   query: {
      //       //     orderNo: orderNo,
      //       //     isBack: "off",
      //       //   },
      //       // });
      //     }
      //   }
      // )
    }
    const getWxPay = () => {
      // 微信公众号支付
      //授权
      const code = getUrlCode()
      if (!code) {
        goAuth()
      } else {
        // state.code = code
        getPayment()
      }
    }
    const goAuth = () => {
      // 用户授权
      const urlNow = encodeURIComponent(window.location.href)
      const scope = 'snsapi_base' //snsapi_userinfo   //静默授权 用户无感知
      const appid = state.payMap.wxAppId || 'wx751141096e75a4ee'
      const url = `https://open.weixin.qq.com/connect/oauth2/authorize?appid=${appid}&redirect_uri=${urlNow}&response_type=code&scope=${scope}&state=STATE&connect_redirect=1#wechat_redirect`
      window.location.replace(url)
    }

    onMounted(() => {
      init()
    })

    return () => (
      <div class={styles.paywxresult}>
        {state.browserStatus && (
          <>
            <div class={styles.container}>
              <CellGroup border={false}>
                <Cell title={'订单金额'} value={'￥' + 0}></Cell>
                <Cell title={'订单信息'} value={'121212'}></Cell>
              </CellGroup>
            </div>

            <div class={styles['order-loading']}>
              <p>{state.payType == 'wx_pub' ? '微信支付' : '支付宝支付'}</p>
              <Loading type="spinner" color="#01C1B5" />
            </div>
          </>
        )}

        {!state.browserStatus && (
          <div class={styles['error-text']}>
            {state.errorText && (
              <Icon v-if="errorText" class={styles['error-icon']} name="warning-o" />
            )}
            {state.errorText}
          </div>
        )}
      </div>
    )
  }
})
